// Event.cpp: implementation of the CEvent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Event.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// constructor creates an event object...
CEvent::CEvent( BOOL bManualReset, 
			   BOOL bInitialState, 
			   LPCTSTR lpName, 
               LPSECURITY_ATTRIBUTES lpEventAttributes) 
{
    m_hHandle = ::CreateEvent( lpEventAttributes, bManualReset, bInitialState, lpName);
    if (IsValidHandle(m_hHandle)) 
	{
        if (lpName)
            m_dwStatus = GetLastError();
        else
            m_dwStatus = NO_ERROR;
    }
    else 
	{
        m_dwStatus = GetLastError();
        ThrowError(m_dwStatus, "Failed to createEvent");
    }
}

// constructor opens an existing named event...
CEvent::CEvent( LPCTSTR lpName, BOOL bInheritHandle, DWORD dwDesiredAccess) 
{
    m_hHandle = ::OpenEvent( dwDesiredAccess, bInheritHandle, lpName);
    if (IsValidHandle(m_hHandle)) 
	{
        m_dwStatus = NO_ERROR;
    }
    else 
	{
        m_dwStatus = GetLastError();
		ThrowError(m_dwStatus, "Failed to openevent");

    }
}

// operations on event object...
BOOL CEvent::Set(void) 
{
    return ::SetEvent(m_hHandle);
}

BOOL CEvent::Reset(void) 
{
    return ::ResetEvent(m_hHandle);
}

BOOL CEvent::Pulse(void) 
{
    return ::PulseEvent(m_hHandle);
}
