// Event.h: interface for the CEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVENT_H__2DF55D6A_DF45_4B6F_9F1E_1B8AAFFC0345__INCLUDED_)
#define AFX_EVENT_H__2DF55D6A_DF45_4B6F_9F1E_1B8AAFFC0345__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "KernelObject.h"

class __declspec(dllexport) CEvent : public CKernelObject  
{
public:
public:
    // constructor creates an event object...
    CEvent( BOOL bManualReset = FALSE, BOOL bInitialState = FALSE, LPCTSTR lpName = NULL, LPSECURITY_ATTRIBUTES lpEventAttributes = NULL);
    
    // constructor opens an existing named event,
    // you must check the status after using this constructor,
    // it will NOT throw an error exception if the object cannot be opened...
    CEvent( LPCTSTR lpName, BOOL bInheritHandle = FALSE, DWORD dwDesiredAccess = EVENT_ALL_ACCESS);

    // operations on event object...
    BOOL Set(void);
    BOOL Reset(void);
    BOOL Pulse(void);

};

#endif // !defined(AFX_EVENT_H__2DF55D6A_DF45_4B6F_9F1E_1B8AAFFC0345__INCLUDED_)
