/********************************************************************
 	created:  10/10/2006  
	filename: KernelObject.cpp
 	
	purpose:	
*********************************************************************/

//
// SYSTEM INCLUDE
//
//
// PROJECT INCLUDE
//
#include <stdafx.h>

//
// LOCAL INCLUDE
//
#include "KernelObject.h"

CKernelObject::CKernelObject() 
{
    m_hHandle = NULL;
    m_dwStatus = ERROR_INVALID_HANDLE;
}

CKernelObject::~CKernelObject() 
{
    if (IsValidHandle(m_hHandle)) {
        ::CloseHandle(m_hHandle);
        m_hHandle = NULL;
    }
}

void CKernelObject::ThrowError( DWORD dwStatus, string const& s) 
{
	throw CShmQueueException(dwStatus, s);
}

DWORD CKernelObject::Status(void) const {
    return m_dwStatus;
}

DWORD CKernelObject::Wait( DWORD dwMilliseconds) {
    return ::WaitForSingleObject( m_hHandle, dwMilliseconds);
}

// wait on the current object and one other...    
DWORD CKernelObject::WaitForTwo( CKernelObject &rWaitableObject, BOOL bWaitAll, DWORD dwMilliseconds) 
{
    HANDLE handles[2];

    // the current object...
    handles[0] = m_hHandle;

    // the parameter object...
    handles[1] = rWaitableObject.GetHandle();

    // wait for the objects...
    return ::WaitForMultipleObjects( 2, handles, bWaitAll, dwMilliseconds);
}

HANDLE CKernelObject::GetHandle(void) const 
{
    if (this != NULL)
        return m_hHandle;
    else
        return NULL;
}

CKernelObject::operator HANDLE() const 
{
    return GetHandle();
}