#include "StdAfx.h"
#include "KernelObject.h"
#include "semaphore.h"
#include "shm.h"
#include "mutex.h"
#include "Event.h"

 #include "ShmQueue.h"
#include "Logger.h"

const static string Key="ABC";

CLogger* CLogger::m_pLogger=NULL;

CLogger::CLogger(void):m_ShmQueue(Key+"-Shm",Key+"-Sem")
{}

CLogger::~CLogger(void)
{
}

CLogger* CLogger::Instance()
{
	try
	{
		if (!m_pLogger)
			m_pLogger= new CLogger;
	}
	catch(CShmQueueException&e)
	{
		ostringstream os;
		os<<e;
		OutputDebugStringA(os.str().c_str());
		m_pLogger=NULL;
	}
	return m_pLogger;
}


void CLogger::Log(const char*p)
{
	if (!m_ShmQueue.Write((char*)p, strlen(p)+1))
	{
		OutputDebugStringA("unable to write to loopbuffer, the buffer is full");
	}
}