/********************************************************************
 	created:  10/11/2006  
	filename: mutex.cpp
 	
	purpose:	
*********************************************************************/

//
// SYSTEM INCLUDE
//

//
// PROJECT INCLUDE
//
#include "StdAfx.h"

//
// LOCAL INCLUDE
//
#include "mutex.h"

// constructor creates a mutex allowing creation parameters to be specified...
CMutex::CMutex( BOOL bInitialOwner, LPCTSTR lpName, LPSECURITY_ATTRIBUTES lpMutexAttributes) {
    m_hHandle = ::CreateMutex( lpMutexAttributes, bInitialOwner, lpName);
    if (IsValidHandle(m_hHandle)) 
	{
        if (lpName)
            m_dwStatus = GetLastError();
        else
            m_dwStatus = NO_ERROR;
    }
    else 
	{
        m_dwStatus = GetLastError();
        ThrowError(m_dwStatus, "Unable to create Mutex");
    }
}

// constructor opens an existing named mutex...
CMutex::CMutex( LPCTSTR lpName, BOOL bInheritHandle, DWORD dwDesiredAccess) {
    m_hHandle = ::OpenMutex( dwDesiredAccess, bInheritHandle, lpName);
    if (IsValidHandle(m_hHandle)) 
	{
        m_dwStatus = NO_ERROR;
    }
    else 
	{
        m_dwStatus = GetLastError();
         ThrowError(m_dwStatus, "Unable to open Mutex");
   }
}

// release a lock on a mutex...
BOOL CMutex::Release(void) 
{
    return ::ReleaseMutex(m_hHandle);
}
