/********************************************************************
 	created:  10/10/2006  
	filename: semaphore.cpp
 	
	purpose:	
*********************************************************************/

//
// SYSTEM INCLUDE
//

//
// PROJECT INCLUDE
//
#include <StdAfx.h>
//
// LOCAL INCLUDE
//
#include "KernelObject.h"
#include "semaphore.h"


// constructor creates a semaphore object...
CSemaphore::CSemaphore( int nInitialCount, int nMaximumCount, LPCTSTR lpName, LPSECURITY_ATTRIBUTES lpSemaphoreAttributes) 
{
    m_hHandle = ::CreateSemaphore( lpSemaphoreAttributes, nInitialCount, nMaximumCount, lpName);
    if (IsValidHandle(m_hHandle)) 
	{
        if (lpName)
            m_dwStatus = GetLastError();
        else
            m_dwStatus = NO_ERROR;
    }
    else {
        m_dwStatus = GetLastError();
        ThrowError(m_dwStatus, "Unable to create semaphore");
    }
}

// constructor opens an existing named semaphore...
CSemaphore::CSemaphore( LPCTSTR lpName, BOOL bInheritHandle, DWORD dwDesiredAccess) {
    m_hHandle = ::OpenSemaphore( dwDesiredAccess, bInheritHandle, lpName);
    if (IsValidHandle(m_hHandle)) 
	{
        m_dwStatus = NO_ERROR;
    }
    else 
	{
        m_dwStatus = GetLastError();
         ThrowError(m_dwStatus, "Unable to OpenSemaphore");
   }
}

// increase the count on a semaphore...
BOOL CSemaphore::Release( LONG lReleaseCount, LONG *plPreviousCount) 
{
    LONG lPreviousCount;
    BOOL bStatus = ::ReleaseSemaphore( m_hHandle, lReleaseCount, &lPreviousCount);
    if (bStatus && plPreviousCount) 
	{
        *plPreviousCount = lPreviousCount;
    }

    return bStatus;
}