/********************************************************************
 	created:  10/10/2006  
	filename: shmqueue.h
 	
	purpose:	
*********************************************************************/
#ifndef _shmqueue_h_10_10_2006
#define _shmqueue_h_10_10_2006

enum ReadStatus
{
	PROGRAM_INTERNAL_ERROR=0,
	RELEASED,
	SUCCESS_WITHOUT_DATA,
	SUCCESS_WITHDATA
};

typedef struct _NOTIFYBUFFER
{
	  LONG TotalSize;							// Amount of data currently in buffer
	  LONG WIndex;							// write count - this increments but is never reset
	  LONG RIndex;							// read point - this is only changed by sysman
	  LONG UnReadDataAvail;							// how many entries?  
	BYTE buffer[4];						// Our actual entries, put 4 bytes for the bytes alignment.
} NOTIFYBUFFER;

typedef struct _SHARED_BUFFER
{
	UINT		ulSig;			// 0xbeefdead
	NOTIFYBUFFER		notify_buffer;

} SHARED_BUFFER, *PSHARED_BUFFER;

class __declspec(dllexport)CShmQueue  
{
public:

	//
	// Create the shmqueue resource
	//
	CShmQueue(	string const&strShmid, 
				string const& semaphoreId, 
				int shmsize,
				int create) ;

	//
	// Passive open the existing shmqueue resource
	//
	CShmQueue(	string const&strShmid, 
				string const& semaphoreId) ;
	
	virtual bool Write(char* pBuffer, size_t size);
	virtual ReadStatus Read(vector<char>&);
	virtual void Release();

protected:
	CSemaphore		m_sem;
	CSharedMemory	m_shm;
	CEvent			m_releaseEvent;

	PSHARED_BUFFER m_pSharedBuffer;

private:
	void InitSharedMemoryContent(int size);

	
};
#endif
