// logserver.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "logserver.h"

#include "../logger/KernelObject.h"
#include "../logger/semaphore.h"
#include "../logger/shm.h"
#include "../logger/mutex.h"
#include "../logger/Event.h"

 #include "../logger/ShmQueue.h"

const static string Key="ABC";
const int SHMSIZE=0x1000000;

CLoggerServer::CLoggerServer(string const& FileName):m_FileStream(FileName.c_str())
{
	if (!m_FileStream)
		m_bValid=false;
	else
	{
		m_bValid=true;
	}
 }


void CLoggerServer::StartLoggerServer(CLoggerServer* p)
{
	try
	{
		CShmQueue shmqueue(Key+"-Shm",Key+"-Sem",SHMSIZE,1);

		vector<char> readBuffer;
		while (1)
		{
			ReadStatus status=shmqueue.Read(readBuffer);
			if (status==PROGRAM_INTERNAL_ERROR)
			{
				OutputDebugStringA("Program Internal Error");
				return;
			}
			if (status==RELEASED)
			{
				OutputDebugStringA("The Logger fetching server was stopped");
				return;
			}
  			if (status==SUCCESS_WITHOUT_DATA)
			{
				OutputDebugStringA("SUCCESS_WITHOUT_DATA is met ");
				Sleep(1000);
				continue;
			}

			char* msg=&readBuffer.front();
			p->UpdateLog(msg);
		}
	}
	catch (CShmQueueException &e)
	{
		ostringstream os;
		os<<e<<endl;
		OutputDebugStringA(os.str().c_str());
	}
}


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{

	CLoggerServer LogServer("E:/debug.log");

	if (LogServer.IsValid())
	{
		CLoggerServer::StartLoggerServer(&LogServer);
	}
	else
	{
		OutputDebugStringA("Unable to open the file E:/debug.log");
	}
 return 0;
}
